function railroad(grm) {
    var rules = {};
    grm.forEach(function(instr) {
        if (instr.rules) {
            if (!rules[instr.name]) {
                rules[instr.name] = [];
            }
            rules[instr.name] = rules[instr.name].concat(instr.rules);
        }
    });
    
    Object.keys(rules).forEach(function(r) {
        console.log(diagram(r).toString());
    });



    function diagram(name) {
        var selectedrules = rules[name];
        var outer = {subexpression: selectedrules};

        function renderTok(tok) {
            // ctx translated to correct position already
            if (tok.subexpression) {
            } else if (tok.ebnf) {
            } else if (tok.literal) {
            } else if (tok.mixin) {
            } else if (tok.macrocall) {
            } else if (tok.tokens) {
            } else if (typeof(tok) === 'string') {
            } else if (tok.constructor === RegExp) {
            } else {
            }
        }
    }
}






var testcase = [ [ { name: 'final',
      rules: 
       [ { tokens: [ 'whit?', 'prog', 'whit?' ],
           postprocess: ' function(d) { return d[1]; } ' } ] },
    { name: 'prog',
      rules: 
       [ { tokens: [ 'prod' ],
           postprocess: ' function(d) { return [d[0]]; } ' },
         { tokens: [ 'prod', 'whit', 'prog' ],
           postprocess: ' function(d) { return [d[0]].concat(d[2]); } ' } ] },
    { name: 'prod',
      rules: 
       [ { tokens: 
            [ 'word',
              'whit?',
              { ebnf: 
                 { subexpression: 
                    [ { tokens: [ { literal: '-' } ] },
                      { tokens: [ { literal: '=' } ] } ] },
                modifier: ':+' },
              { literal: '>' },
              'whit?',
              'expression+' ],
           postprocess: ' function(d) { return {name: d[0], rules: d[5]}; } ' },
         { tokens: 
            [ 'word',
              { literal: '[' },
              'wordlist',
              { literal: ']' },
              'whit?',
              { ebnf: 
                 { subexpression: 
                    [ { tokens: [ { literal: '-' } ] },
                      { tokens: [ { literal: '=' } ] } ] },
                modifier: ':+' },
              { literal: '>' },
              'whit?',
              'expression+' ],
           postprocess: ' function(d) {return {macro: d[0], args: d[2], exprs: d[8]}} ' },
         { tokens: [ { literal: '@' }, 'whit?', 'js' ],
           postprocess: ' function(d) { return {body: d[2]}; } ' },
         { tokens: [ { literal: '@' }, 'word', 'whit', 'word' ],
           postprocess: ' function(d) { return {config: d[1], value: d[3]}; } ' },
         { tokens: [ { literal: '@include' }, 'whit?', 'string' ],
           postprocess: ' function(d) {return {include: d[2].literal, builtin: false}} ' },
         { tokens: [ { literal: '@builtin' }, 'whit?', 'string' ],
           postprocess: ' function(d) {return {include: d[2].literal, builtin: true }} ' } ] },
    { name: 'expression+',
      rules: 
       [ { tokens: [ 'completeexpression' ] },
         { tokens: 
            [ 'expression+',
              'whit?',
              { literal: '|' },
              'whit?',
              'completeexpression' ],
           postprocess: ' function(d) { return d[0].concat([d[4]]); } ' } ] },
    { name: 'expressionlist',
      rules: 
       [ { tokens: [ 'completeexpression' ] },
         { tokens: 
            [ 'expressionlist',
              'whit?',
              { literal: ',' },
              'whit?',
              'completeexpression' ],
           postprocess: ' function(d) { return d[0].concat([d[4]]); } ' } ] },
    { name: 'wordlist',
      rules: 
       [ { tokens: [ 'word' ] },
         { tokens: [ 'wordlist', 'whit?', { literal: ',' }, 'whit?', 'word' ],
           postprocess: ' function(d) { return d[0].concat([d[4]]); } ' } ] },
    { name: 'completeexpression',
      rules: 
       [ { tokens: [ 'expr' ],
           postprocess: ' function(d) { return {tokens: d[0]}; } ' },
         { tokens: [ 'expr', 'whit?', 'js' ],
           postprocess: ' function(d) { return {tokens: d[0], postprocess: d[2]}; } ' } ] },
    { name: 'expr_member',
      rules: 
       [ { tokens: [ 'word' ], postprocess: ' id ' },
         { tokens: [ { literal: '$' }, 'word' ],
           postprocess: ' function(d) {return {mixin: d[1]}} ' },
         { tokens: [ 'word', { literal: '[' }, 'expressionlist', { literal: ']' } ],
           postprocess: ' function(d) {return {macrocall: d[0], args: d[2]}} ' },
         { tokens: [ 'string' ], postprocess: ' id ' },
         { tokens: [ 'charclass' ], postprocess: ' id ' },
         { tokens: 
            [ { literal: '(' },
              'whit?',
              'expression+',
              'whit?',
              { literal: ')' } ],
           postprocess: ' function(d) {return {\'subexpression\': d[2]} ;} ' },
         { tokens: [ 'expr_member', 'whit?', 'ebnf_modifier' ],
           postprocess: ' function(d) {return {\'ebnf\': d[0], \'modifier\': d[2]}; } ' } ] },
    { name: 'ebnf_modifier',
      rules: 
       [ { tokens: [ { literal: ':+' } ], postprocess: ' id ' },
         { tokens: [ { literal: ':*' } ], postprocess: ' id ' },
         { tokens: [ { literal: ':?' } ], postprocess: ' id ' } ] },
    { name: 'expr',
      rules: 
       [ { tokens: [ 'expr_member' ] },
         { tokens: [ 'expr', 'whit', 'expr_member' ],
           postprocess: ' function(d){ return d[0].concat([d[2]]); } ' } ] },
    { name: 'word',
      rules: 
       [ { tokens: [ /[\w\?\+]/ ],
           postprocess: ' function(d){ return d[0]; } ' },
         { tokens: [ 'word', /[\w\?\+]/ ],
           postprocess: ' function(d){ return d[0]+d[1]; } ' } ] },
    { name: 'string',
      rules: 
       [ { tokens: [ { literal: '"' }, 'charset', { literal: '"' } ],
           postprocess: ' function(d) { return { literal: d[1].join("") }; } ' } ] },
    { name: 'charset',
      rules: 
       [ { tokens: [ 'null' ] },
         { tokens: [ 'charset', 'char' ],
           postprocess: ' function(d) { return d[0].concat([d[1]]); } ' } ] },
    { name: 'char',
      rules: 
       [ { tokens: [ /[^\\"]/ ],
           postprocess: ' function(d) { return d[0]; } ' },
         { tokens: [ { literal: '\\' }, /./ ],
           postprocess: ' function(d) { return JSON.parse("\\""+"\\\\"+d[1]+"\\""); } ' } ] },
    { name: 'charclass',
      rules: 
       [ { tokens: [ { literal: '.' } ],
           postprocess: ' function(d) { return new RegExp("."); } ' },
         { tokens: [ { literal: '[' }, 'charclassmembers', { literal: ']' } ],
           postprocess: ' function(d) { return new RegExp("[" + d[1].join(\'\') + "]"); } ' } ] },
    { name: 'charclassmembers',
      rules: 
       [ { tokens: [ 'null' ] },
         { tokens: [ 'charclassmembers', 'charclassmember' ],
           postprocess: ' function(d) { return d[0].concat([d[1]]); } ' } ] },
    { name: 'charclassmember',
      rules: 
       [ { tokens: [ /[^\\\]]/ ],
           postprocess: ' function(d) { return d[0]; } ' },
         { tokens: [ { literal: '\\' }, /./ ],
           postprocess: ' function(d) { return d[0] + d[1]; } ' } ] },
    { name: 'js',
      rules: 
       [ { tokens: 
            [ { literal: '{' },
              { literal: '%' },
              'jscode',
              { literal: '%' },
              { literal: '}' } ],
           postprocess: ' function(d) { return d[2]; } ' } ] },
    { name: 'jscode',
      rules: 
       [ { tokens: [ 'null' ], postprocess: ' function() {return "";} ' },
         { tokens: [ 'jscode', /[^%]/ ],
           postprocess: ' function(d) {return d[0] + d[1];} ' },
         { tokens: [ 'jscode', { literal: '%' }, /[^}]/ ],
           postprocess: ' function(d) {return d[0] + d[1] + d[2]; } ' } ] },
    { name: 'whit',
      rules: 
       [ { tokens: [ 'whitraw' ] },
         { tokens: [ 'whitraw?', 'comment', 'whit?' ] } ] },
    { name: 'whit?',
      rules: [ { tokens: [ 'null' ] }, { tokens: [ 'whit' ] } ] },
    { name: 'whitraw',
      rules: [ { tokens: [ /[\s]/ ] }, { tokens: [ 'whitraw', /[\s]/ ] } ] },
    { name: 'whitraw?',
      rules: [ { tokens: [ 'null' ] }, { tokens: [ 'whitraw' ] } ] },
    { name: 'comment',
      rules: [ { tokens: [ { literal: '#' }, 'commentchars', { literal: '\n' } ] } ] },
    { name: 'commentchars',
      rules: 
       [ { tokens: [ 'null' ] },
         { tokens: [ 'commentchars', /[^\n]/ ] } ] } ] ][0]




test2 = [ [ { name: 'a',
      rules: 
       [ { tokens: 
            [ { ebnf: { literal: 'cow' }, modifier: ':?' },
              { literal: 'bee' },
              /[abc]/,
              { subexpression: [ { tokens: [ 'd' ] }, { tokens: [ 'e' ] }, { tokens: [ 'f' ] } ] } ] },
         { tokens: [ 'x' ] },
         { tokens: [ 'y' ] },
         { tokens: [ 'z' ] } ] } ] ][0]

railroad(testcase);
